
/* readinfo.c - Read a Terak disk image directory entries */
/* Copyright 1994 Syndesis Corporation */
/* July 12, 1990 */

#include <stdio.h>
#include <string.h>

#include "teradecl.h"
#include "teravars.h"


/* Read in a dirRoot struct, the volume info */

USHORT readFileInfo( FILE *infp, dirEntry *dir )
{
USHORT lerr;
dirEntry *ptr;
short each;


    /* Read the volume info into dirRoot */
    /* Advance to block 2 of the disk, plus beyond the volume info */
    fseek( infp, (long) (0x0200 * 2) + 26, SEEK_SET );

    /* Read each element */
    ptr = dir;
    for (each=0; each<MAX_DIR_ENTRIES-1; each++) {

        if ((lerr=getShort( infp, &ptr->firstBlk )) != TE_NOERROR) {
            goto out;
        }
        if ((lerr=getShort( infp, &ptr->lastBlk )) != TE_NOERROR) {
            goto out;
        }
        if ((lerr=getShort( infp, &ptr->fileKind )) != TE_NOERROR) {
            goto out;
        }

        if (fread( &ptr->fileName, (size_t) 16, (size_t) 1, infp ) != 1) {
            lerr = TE_BADREAD;
            goto out;
        }
        unPascalStr( &ptr->fileName[0] );

        if ((lerr=getShort( infp, &ptr->lastByte )) != TE_NOERROR) {
            goto out;
        }
        if ((lerr=getShort( infp, &ptr->lastAccess )) != TE_NOERROR) {
            goto out;
        }

        ptr ++;
    }

    lerr = TE_NOERROR;
out:
    return lerr;
} 
