
/* readvol.c - Read a Terak disk image file's volume descriptor */
/* Copyright 1994 Syndesis Corporation */
/* July 12, 1990 */

#include <stdio.h>
#include <string.h>

#include "teradecl.h"
#include "teravars.h"


/* Read in a dirRoot struct, the volume info */

USHORT readVolInfo( FILE *infp, dirRoot *root )
{
USHORT lerr;


    /* Read the volume info into dirRoot, from block 2 of the disk */
    fseek( infp, (long) (0x0200 * 2), SEEK_SET );

    /* Read each element */
    if ((lerr=getShort( infp, &root->firstBlk )) != TE_NOERROR) {
        goto out;
    }
    if ((lerr=getShort( infp, &root->lastBlk )) != TE_NOERROR) {
        goto out;
    }
    if ((lerr=getShort( infp, &root->fileKind )) != TE_NOERROR) {
        goto out;
    }

    if (fread( &root->volName, (size_t) 8, (size_t) 1, infp ) != 1) {
        lerr = TE_BADREAD;
        goto out;
    }
    unPascalStr( &root->volName[0] );

    if ((lerr=getShort( infp, &root->eovBlk )) != TE_NOERROR) {
        goto out;
    }
    if ((lerr=getShort( infp, &root->numFiles )) != TE_NOERROR) {
        goto out;
    }
    if ((lerr=getShort( infp, &root->loadTime )) != TE_NOERROR) {
        goto out;
    }
    if ((lerr=getShort( infp, &root->lastBoot )) != TE_NOERROR) {
        goto out;
    }

    /* Four bytes left over before first file directory entry */

    lerr = TE_NOERROR;
out:
    return lerr;
} 

